/* Program # 10
     Write a program to fill a triangle using scan line area filling
     algorithm (Use appropriate data structures for the implementation).
*/

#include<iostream.h>
#include<graphics.h>
#include<math.h>
#include<stdlib.h>

struct edge {	int y,ymin;	float m,x;	edge *next;	};

edge *setedge(int x1,int y1,int x2,int y2)
{
	edge *temp;
	temp=(edge *)malloc(sizeof(edge));
	temp->x=y1<y2?x1:x2;
	temp->y=y1>y2?y1:y2;
	temp->ymin=y1<y2?y1:y2;
	if(y2!=y1)	temp->m=(float)(x2-x1)/(y2-y1);
	else	temp->m=0;
	temp->next=NULL;
	return temp;
}

edge *insert(edge *e,edge *aet)
{
	if(aet==NULL)	return e;
	edge *p=aet,*q=aet;
	while(p!=NULL && p->x<e->x)
	{	q=p;	p=p->next;	}
	if(p==q)
	{	if(e->x<p->x)	{	e->next=p;	return e;	}
		else	{	e->next=p->next;	p->next=e;	return aet;	}
	}
	e->next=p;
	q->next=e;
	return aet;
}

edge *remove(edge *aet,int y)
{
	edge *p=aet,*q=aet;
	while(p)
	{
		if(p->y==y)
		{	if(p==q)
			{	p=p->next;	free(q);	aet=q=p;	}
			else
				{	q->next=p->next;	free(p);	}
		}
		else
		{	q=p;	p=p->next;	}
	}
	return aet;
}

void fill(edge *aet,int y)
{
	if(aet==NULL) return;
	int parity=1,x1=0,x2=0;
	edge *p=aet;
		do
		{	parity *= -1;
			x1=x2;
			x2=p->x;
			if(parity==1)
				for(int i=x1;i<x2;i++)
					putpixel(i,y,GREEN);
			p=p->next;
		}while(p);
}

void updatex(edge *aet)
{
	edge *p=aet;
	while(p)
	{	p->x+=p->m;	p=p->next;	}
}

void main()
{
	int a[3],b[3];
	cout<<"\nEnter the three points:";
	for(int i=0;i<3;i++)
		cin>>a[i]>>b[i];
	int g1=DETECT,g2;
	initgraph(&g1,&g2,"c:\\tc\\bgi");
	edge *e[3];
	e[0]=setedge(a[0],b[0],a[1],b[1]);
	e[1]=setedge(a[1],b[1],a[2],b[2]);
	e[2]=setedge(a[2],b[2],a[3],b[3]);
	int y=((b[0]<b[1])?b[0]:b[1])<b[2]?((b[0]<b[1])?b[0]:b[1]):b[2];
	edge *aet=NULL;
	do
	{	for(int i=0;i<3;i++)
			if(e[i]->ymin==y)
				aet=insert(e[i],aet);
		aet=remove(aet,y);
		fill(aet,y);
		y++;
		updatex(aet);
	}while(aet!=NULL);

	cin.get(); cin.get();
	closegraph();
}