/* PROGRAM NO. 3 */

/* PROGRAM TO DISPLAY A LINE GRAPH USING BRESENHAM'S LINE ALGORITHM.
   THE INPUT TO THE PROGRAM IS A SET OF VALUES CORRESPONDING TO THE
   X AND Y AXES.  DATA POINTS ARE DISPLAYED AS ASTERISKS JOINED
   WITH STRAIGHT LINE SEGMENT, AND X AND Y AXES ARE LABELLED ACCORDING
   TO INPUT SPECIFICATIONS */

#include<stdio.h>
#include<graphics.h>

void bresline(int x1,int y1,int x2,int y2)
{
  int dx,dy,x,y,xend,p,temp=0;
  int indc=1;
  if((x1<x2 && y1>y2) || (y2>y1 && x2<x1))
  indc=0;
  dx=abs(x1-x2);
  dy=abs(y1-y2);
  if(dy>dx)
	{
    temp=dy;
    dy=dx;
    dx=temp;
    temp=x1;
    x1=y1;
    y1=temp;
    temp=x2;
    x2=y2;
    y2=temp;
    temp=1;
  }
  p=2*dy-dx;
  if(x1>x2)
  {
    x=x2;
    y=y2;
    xend=x1;
	}
  else
  {
    x=x1;
    y=y1;
    xend=x2;
  }
  if(!temp)
		putpixel(x,y,1);
  else
		putpixel(y,x,1);
  while(x<xend)
  {
    x++;
    if(p<0)
			p+=2*dy;
    else
		{
			if(indc)
				y++;
			else
				y--;
				p+=2*(dy-dx);
		}
		if(!temp)
			putpixel(x,y,1);
		else
			putpixel(y,x,1);
	}
}


void main()
{
	int gd=DETECT,gm;
	int hvalue[25];
	int hmax=0;
	char barlabel[20][10],*outstr;
	char ylabel[30],xlabel[30];
	int n,i,j,temp,temp1;
	float x1,x2,y1,y2,inc,hratio;
	clrscr();
	initgraph(&gd,&gm,"");
	printf("Line graph using Bresenham's line algorithm\n");
	printf("Enter the number of points\n");
	scanf("%d",&n);
	printf("Enter the label for yaxis\n");
	fflush(stdin);
	gets(ylabel);
	printf("Enter the label for xaxis\n");
	fflush(stdin);
	gets(xlabel);
	printf("Enter the coordinater for ypoints\n");
	for(i=0;i<n;i++)
	{
		scanf("%d",&hvalue[i]);
		if(hmax<hvalue[i])
		hmax=hvalue[i];
	}
	printf("Enter the coordinates for xpoints\n");
	for(i=0;i<n;i++)
	{
		fflush(stdin);
		gets(barlabel[i]);
	}
	cleardevice();
	bresline(60,10,60,430);
	x1=55;
	y1=330;
	i=1;
	while((hmax/i)>9)
		i*=10;
	hmax=((hmax/i)+1)*i;
	hratio=400.0/hmax;
	temp=temp1=hmax/4;
	settextjustify(RIGHT_TEXT,CENTER_TEXT);
	for(i=0;i<4;i++)
	{
		bresline(x1,y1,x1+10,y1);
		sprintf(outstr,"%d",temp);
		outtextxy(x1-5,y1,outstr);
		temp+=temp1;
		y1-=100;
	}
	bresline(50,430,60,430);
	outtextxy(45,430,"0");
	settextstyle(DEFAULT_FONT,VERT_DIR,1);
	settextjustify(CENTER_TEXT,CENTER_TEXT);
	outtextxy(10,210,ylabel);
	bresline(60,430,620,430);
	inc=500/n;
	x1=90;
	settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
	for(i=0;i<n-1;i++)
	{
		y1=hratio*hvalue[i];
		y2=hratio*hvalue[i+1];
		bresline(x1,430-y1,x1+inc,430-y2);
		outtextxy(x1,430-y1,"*");
		if(!(i%2))
			outtextxy(x1,440,barlabel[i]);
		else
			outtextxy(x1,445,barlabel[i]);
		x1+=inc;
	}
	y1=hratio*hvalue[i];
	outtextxy(x1,430-y1,"*");
	if(!(i%2))
		outtextxy(x1,440,barlabel[i]);
	else
		outtextxy(x1,445,barlabel[i]);
	outtextxy(340,475,xlabel);
	getch();
	closegraph();
}








