/* PROGRAM NO.7 */

/* PROGRAM TO IMPLEMENT THE COHEN-SUTHERLAND LINE CLIPPING ALGORITHM.
	 MAKE PROVISION TO SPECIFY THE INPUT LINE, WINDOW FOR CLIPPING
	 AND VIEWPORT FOR DISPLAYING THE CLIPPED IMAGE.
	 ( USE BUILT-IN LINE AND RECTANGLE FUNCTION )        */


#include<stdio.h>
#include<graphics.h>
#include<stdlib.h>
#define true 1
#define false 0
#define draw_line(color) setcolor(color);line(x1,y1,x2,y2);

typedef enum{left,right,top,bottom} boundaries;
typedef int code[4];
code code1,code2;
int x1,y1,x2,y2;
int x_left,x_right,y_top,y_bottom;
int x_view_left,x_view_right,y_view_top,y_view_bottom;

void main()
{
	int clip_line();
	void transform();
	int option,display;
	int gdrv=DETECT,gmode;
	initgraph(&gdrv,&gmode,"");
	do
	{
		printf("1:Clipping\n");
		printf("2:Exit\n");
		printf("Enter the choice\n");
		scanf("%d",&option);
		switch(option)
		{
			case 1: printf("Enter the line co-ordinates\n");
							printf("Enter the first point\n");
							scanf("%d %d",&x1,&y1);
							printf("Enter the second point\n");
							scanf("%d %d",&x2,&y2);
							cleardevice();
							draw_line(WHITE);
							getch();
							cleardevice();
							printf("enter the clipping window\n");
							scanf("%d %d %d %d",&x_left,&y_top,&x_right,&y_bottom);
							cleardevice();
							draw_line(WHITE);
							getch();
							setcolor(WHITE);
							setlinestyle(DASHED_LINE,1,1);
							rectangle(x_left,y_top,x_right,y_bottom);
							outtextxy((x_right-x_left)/2,y_top-10,"Window");
							getch();
							cleardevice();
							printf("Enter the viewport co-ordinates\n");
							scanf("%d %d %d %d",&x_view_left,&y_view_top,
															&x_view_right,&y_view_bottom);
							cleardevice();
							draw_line(WHITE);
							getch();
							setcolor(WHITE);
							setlinestyle(DASHED_LINE,1,1);
							rectangle(x_left,y_top,x_right,y_bottom);
							getch();
							cleardevice();
							rectangle(x_left,y_top,x_right,y_bottom);
							setcolor(WHITE);
							setlinestyle(SOLID_LINE,1,1);
							rectangle(x_view_left,y_view_top,x_view_right,y_view_bottom);
							getch();
							display=clip_line();
							draw_line(WHITE);
							if(display)
							{
								transform(&x1,&y1);
								transform(&x2,&y2);
								draw_line(WHITE);
								getch();
							}
							closegraph();
							break;
			case 2: exit(0);
		}
	}
	while(option!=2);
}

int clip_line()
{
	int done=false,display=false;
	float slope;
  int dx;
  void encode();
  int accept();
  int reject();
  void swap_if_needed();
  while(!done)
  {
    encode(x1,y1,code1);
    encode(x2,y2,code2);
    if(accept()) done=display=true;     /* both points are inside */
    else
    {
      if(reject()) done=true;
      else
      {
				swap_if_needed();
				dx=x2-x1;
				if(dx!=0)
					slope=(y2-y1)/(float)dx;
				if(code1[left])
				{
					y1+=(x_left-x1)*slope;
					x1=x_left;
				}
				else
				if(code1[right])
				{
					y1+=(x_right-x1)*slope;
					x1=x_right;
				}
				else
				if(code1[top])
				{
					if(dx!=0) x1+=(y_top-y1)/slope;
						y1=y_top;
				}
				else
				if(code1[bottom])
				{
					if(dx!=0) x1+=(y_bottom-y1)/slope;
						y1=y_bottom;
				}
			}
		}
	}/*while*/
	return(display);
}

void encode(int x,int y,code c)
{
	if(x<x_left) c[left]=true;
		else c[left]=false;
	if(x>x_right) c[right]=true;
		else c[right]=false;
	if(y<y_top) c[top]=true;
		else c[top]=false;
	if(y>y_bottom) c[bottom]=true;
		else c[bottom]=false;
}

int accept()
{
	int accept_flag=true;
	boundaries b;
	for(b=left;b<=bottom;b++)
	if(code1[b]||code2[b])
		accept_flag=false;
	return(accept_flag);
}

int reject()
{
	int reject_flag=false;
	boundaries b;
	for(b=left;b<=bottom;b++)
	if(code1[b]&&code2[b])
		reject_flag=true;
	return(reject_flag);
}

void swap_if_needed()
{
	int tmp;
	int outside();
	boundaries i;
	if(!outside(code1))
	{
		tmp=x1;
		x1=x2;
		x2=tmp;
		tmp=y1;
		y1=y2;
		y2=tmp;
		for(i=left;i<=bottom;i++)
		{
			tmp=code1[i];
			code1[i]=code2[i];
			code2[i]=tmp;
		}
	}
	return;
}

int outside(code c)
{
	boundaries b;
	int out=false;
	for(b=left;b<=bottom;b++)
	if(c[b])
		out=true;
	return(out);
}

void transform(int *xv,int *yv)
{
 *xv=((x_view_right-x_view_left)/(x_right-x_left))*(*xv-x_left)+x_view_left;
 *yv=((y_view_bottom-y_view_top)/(y_bottom-y_top))*(*yv-y_top)+y_view_top;
}