/* Progrm # 9
     Write a program to implement 3D rotation with respect to z axis (wire
     frame model of a cube). Use appropriate data structures to manipulate
     the wire frame model.
*/

#include <stdio.h>
#include <graphics.h>
#include <conio.h>
#include <math.h>
#include <dos.h>

#define RAD(x) ((x) * (M_PI/180.0))

typedef struct {
double x,y,z;
} point;

void cube(point *p) {
 static pointtype pt[8];
 static double theta = RAD(45);

 for (int i = 0; i < 8; i++) {
  pt[i].x = p[i].x - cos(theta) * (-1) * p[i].z;
  pt[i].y = p[i].y + sin(theta) * p[i].z;
 }

 line(pt[0].x, pt[0].y, pt[1].x, pt[1].y);//0-1-2-3-0
 line(pt[1].x, pt[1].y, pt[2].x, pt[2].y);
 line(pt[2].x, pt[2].y, pt[3].x, pt[3].y);
 line(pt[3].x, pt[3].y, pt[0].x, pt[0].y);
 line(pt[4].x, pt[4].y, pt[5].x, pt[5].y);//4-5-6-7-4
 line(pt[5].x, pt[5].y, pt[6].x, pt[6].y);
 line(pt[6].x, pt[6].y, pt[7].x, pt[7].y);
 line(pt[7].x, pt[7].y, pt[4].x, pt[4].y);
 line(pt[0].x, pt[0].y, pt[4].x, pt[4].y);//0-4
 line(pt[1].x, pt[1].y, pt[5].x, pt[5].y);//1-5
 line(pt[2].x, pt[2].y, pt[6].x, pt[6].y);//2-6
 line(pt[3].x, pt[3].y, pt[7].x, pt[7].y);//3-7
}

void cube_rotate(point *p) {
 double theta = RAD(5), px, py;
 int i;

 while (!kbhit()) {
  cube(p);
  delay(40);
  for (i = 0; i < 4; i++)
   p[i].x -= 250, p[i].y -= 150, p[i + 4].x -= 200, p[i + 4].y -= 100;
  for (i = 0; i < 8; i++) {
   px = p[i].x; py = p[i].y;
   p[i].x = px * cos(theta) - py * sin(theta);
   p[i].y = px * sin(theta) + py * cos(theta);
  }
  for (i = 0; i < 4; i++)
   p[i].x += 250, p[i].y += 150, p[i + 4].x += 200, p[i + 4].y += 100;
  cleardevice();
 }
}

void main() {
 int gd = DETECT, gm;
 point p[8];

 initgraph(&gd, &gm, "c:\\tc\\bgi");
 setbkcolor(12);
 setcolor(WHITE);

 p[0].x = 200; p[0].y = 100; p[0].z = 0;
 p[1].x = 300; p[1].y = 100; p[1].z = 0;
 p[2].x = 300; p[2].y = 200; p[2].z = 0;
 p[3].x = 200; p[3].y = 200; p[3].z = 0;
 p[4].x = 150; p[4].y = 50;  p[4].z = 150;
 p[5].x = 250; p[5].y = 50;  p[5].z = 150;
 p[6].x = 250; p[6].y = 150; p[6].z = 150;
 p[7].x = 150; p[7].y = 150; p[7].z = 150;

 cube_rotate(p);
 closegraph();
}


